# --
# This software comes with ABSOLUTELY NO WARRANTY. For details, see
# the enclosed file COPYING for license information (GPL). If you
# did not receive this file, see http://www.gnu.org/licenses/gpl.txt.
# --
#
Summary:	The Open Ticket Request System
Name:		otrs
Version:	3.1.17
License:	GNU GENERAL PUBLIC LICENSE Version 2, June 1991
Group:		Applications/Mail
URL:		http://www.otrs.org/

Requires:	perl perl-DBI mysql perl-libwww-perl
Requires:	perl(URI) perl(Date::Format) perl(Net::DNS) perl(IO::Socket::SSL) perl(XML::Parser)
%if 0%{?suse_version}
%if 0%{?suse_version} > 1020
BuildRequires:  fdupes
%endif
Requires:	perl-GD perl-GDGraph perl-GDTextUtil perl-Net-DNS perl-Digest-MD5 apache2 apache2-mod_perl mysql-client
Requires:	perl-Msql-Mysql-modules mysql-shared procmail
BuildRequires:	apache2 apache2-devel pwdutils
PreReq:		pwdutils
%define _apxs	/usr/sbin/apxs2
%define _apausr wwwrun
%define _apagrp www
%define _otrsusr otrs
%define _otrsgrp nogroup
%define _initdir /etc/init.d
%endif

%if 0%{?fedora_version} || 0%{?centos_version} || 0%{?rhel_version}
Requires:	perl-URI mod_perl httpd mysql mysql-server procmail
BuildRequires:	httpd httpd-devel shadow-utils
PreReq:		shadow-utils
%define _apxs	/usr/sbin/apxs
%define _apausr apache
%define _apagrp apache
%define _otrsusr otrs
%define _otrsgrp apache
%define _initdir /etc/rc.d/init.d
%endif

%define _apaconfdir %(%{_apxs} -q sysconfdir)/conf.d/
 
Autoreqprov:	no
Release:	1.2
Source0:	%{name}-%{version}.tar.bz2
Patch0:		%{name}-suse-init.diff
BuildRoot:	%{_tmppath}/%{name}-%{version}-build

%description
The Open Ticket Request System (http://otrs.org/) is a web based ticket system.

Feedback: feedback@otrs.org


Authors:
--------
  Carsten Gross <carsten at siski.de>
  Christian Schoepplein <cs at otrs.de>
  Franz Breu <breu.franz at bogen.net>
  Fred van Dijk <fvandijk at marklin.nl>
  Lars MueLLER <lars at m5r.de>
  Nicolas Goralski <ngoralski at oceanet-technology.com>
  Richard Kammermayer <rk at otrs.de>
  Stefan Rother <sr at otrs.de>
  Thomas Raith <tr at otrs.de>
  Vladimir Gerdjikov <gerdjikov at gerdjikovs.net>
  Martin Edenhofer <me at otrs.de>

  OTRS is an Open source Ticket Request System with many features to manage
  customer telephone calls and e-mails. It is distributed under the GNU
  General Public License (GPL) and tested on Linux, Solaris, AIX, FreeBSD,
  OpenBSD and Mac OS 10.x. Do you receive many e-mails and want to answer
  them with a team of agents? You're going to love the OTRS!

  Feature list:

   Web-Interface:
    - Agent web interface for viewing and working on all customer requests
    - Admin web interface for changing system things
    - Customer web interface for viewing and sending infos to the agents
    - Webinterface with themes support
    - Multi language support (Brazilian Portuguese, Bulgarian, Dutch, English,
       Finnish, French, German, Italian and Spanish)
    - customize the output templates (dtl) release independently
    - Webinterface with attachment support
    - easy and logical to use

   Email-Interface:
    - PGP support
    - SMIME support
    - MIME support (attachments)
    - dispatching of incoming email via email addess or x-header
    - autoresponders for customers by incoming emails (per queue)
    - email-notification to the agent by new tickets, follow ups or lock timeouts

   Ticket:
    - custom queue view and queue view of all requests
    - Ticket locking
    - Ticket replies (standard responses)
    - Ticket autoresponders per queue
    - Ticket history, evolution of ticket status and actions taken on ticket
    - abaility to add notes (with different note types) to a ticket
    - Ticket zoom feature
    - Tickets can be bounced or forwarded to other email addresses
    - Ticket can be moved to a different queue (this is helpful if emails are
       for a specific subject)
    - Ticket priority
    - Ticket time accounting
    - Ticket merge feature
    - Ticket ACL support
    - content Fulltext search

   System:
    - creation and configuration of user accounts, and groups
    - creation of standard responses
    - Signature configuration per queue
    - Salutation configuration per queue
    - email-notification of administrators
    - email-notification sent to problem reporter (by create, locked, deleted,
       moved and closed)
    - submitting update-info (via email or webinterface).
    - deadlines for trouble tickets
    - ASP (activ service providing) support
    - TicketHook free setable like 'Call#', 'MyTicket#', 'Request#' or 'Ticket#'
    - Ticket number format free setable
    - different levels of permissions/access-rights.
    - central database, Support of different SQL databases (e. g. MySQL, PostgeSQL, ...)
    - user authentication agains database or ldap directory
    - easy to develope you own addon's (OTRS API)
    - easy to write different frontends (e. g. X11, console, ...)
    - own package manager (e. g. for application modules like webmail, calendar or
       filemanager)
    - a fast and useful application


%if 0%{?suse_version} < 900
SuSE series: ap
%endif

%prep
%setup
%patch0

%build
# copy config file
cp Kernel/Config.pm.dist Kernel/Config.pm
cd Kernel/Config/ && for foo in *.dist; do cp $foo `basename $foo .dist`; done && cd ../../
# copy all crontab dist files
for foo in var/cron/*.dist; do mv $foo var/cron/`basename $foo .dist`; done
# copy all .dist files
cp .procmailrc.dist .procmailrc
cp .fetchmailrc.dist .fetchmailrc
cp .mailfilter.dist .mailfilter

%install
# delete old RPM_BUILD_ROOT
rm -rf $RPM_BUILD_ROOT
# set DESTROOT
export DESTROOT="/opt/otrs/"
# create RPM_BUILD_ROOT DESTROOT
mkdir -p $RPM_BUILD_ROOT/$DESTROOT/
# copy files
cp -R . $RPM_BUILD_ROOT/$DESTROOT
# install init-Script and rc.config entry
%__install -d -m 755 $RPM_BUILD_ROOT%{_initdir}
%__install -d -m 755 $RPM_BUILD_ROOT%{_sbindir}
%__install -d -m 755 $RPM_BUILD_ROOT/etc/sysconfig
%if 0%{?suse_version}
%__install -d -m 744 $RPM_BUILD_ROOT/var/adm/fillup-templates
%endif
%__install -d -m 755 $RPM_BUILD_ROOT%{_apaconfdir}

%if 0%{?suse_version}
# replace apache with apache2
sed  "s/rcapache/rcapache2/" scripts/suse-rcotrs-config > /tmp.otrs.$$ && mv /tmp.otrs.$$ scripts/suse-rcotrs-config
sed  "s/apache/apache2/" scripts/suse-rcotrs > /tmp.otrs.$$ && mv /tmp.otrs.$$ scripts/suse-rcotrs
%__install -D -m 644 scripts/suse-rcotrs-config $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.otrs
%__install -m 755 scripts/suse-rcotrs $RPM_BUILD_ROOT%{_initdir}/otrs
rm -f $RPM_BUILD_ROOT/sbin/otrs
ln -s ../../etc/init.d/otrs $RPM_BUILD_ROOT%{_sbindir}/rcotrs
%else
%__install -m 755 scripts/redhat-rcotrs $RPM_BUILD_ROOT%{_initdir}/otrs
%__install -m 644 scripts/redhat-rcotrs-config $RPM_BUILD_ROOT/etc/sysconfig/otrs
%endif
%__install -m 644 scripts/apache2-httpd.include.conf $RPM_BUILD_ROOT%{_apaconfdir}/otrs.conf
%if 0%{?suse_version} > 1020
%fdupes $RPM_BUILD_ROOT/opt/otrs
%endif

# set permission
useradd %{_otrsusr} || :
#$RPM_BUILD_ROOT/opt/otrs/bin/otrs.SetPermissions.pl $RPM_BUILD_ROOT/opt/otrs %{_otrsusr} %{_apausr} %{_otrsgrp} %{_apagrp} || :
$RPM_BUILD_ROOT/opt/otrs/bin/otrs.SetPermissions.pl --otrs-user=%{_otrsusr} --web-user=%{_apausr} --otrs-group=%{_otrsgrp} --web-group=%{_apagrp} $RPM_BUILD_ROOT/opt/otrs || :
%pre
# remember about the installed version
if test -e /opt/otrs/RELEASE; then
    cat /opt/otrs/RELEASE|grep VERSION|sed 's/VERSION = //'|sed 's/ /-/g' > /tmp/otrs-old.tmp
fi
# useradd
echo -n "Check OTRS user (/etc/passwd)... "
if cat /etc/passwd | grep %{_otrsusr} > /dev/null ; then
    echo "%{_otrsusr} exists."
    # update groups
    usermod -g %{_otrsgrp} %{_otrsusr}
    # update home dir
    usermod -d /opt/otrs %{_otrsusr}
else
    useradd %{_otrsusr} -d /opt/otrs/ -s /bin/false -g %{_otrsgrp} -c 'OTRS System User' && echo "%{_otrsusr} added."
fi


%post
%if 0%{?suse_version}
# sysconfig
%{fillup_and_insserv}
%endif

# if it's a major-update backup old version templates (maybe not compatible!)
if test -e /tmp/otrs-old.tmp; then
    TOINSTALL=`echo %{version}| sed 's/..$//'`
    OLDOTRS=`cat /tmp/otrs-old.tmp`
    if echo $OLDOTRS | grep -v "$TOINSTALL" > /dev/null; then
        echo "backup old (maybe not compatible) templates (of $OLDOTRS)"
        for i in /opt/otrs/Kernel/Output/HTML/Standard/*.rpmnew;
            do BF=`echo $i|sed 's/.rpmnew$//'`; mv -v $BF $BF.backup_maybe_not_compat_to.$OLDOTRS; mv $i $BF;
        done
    fi
    rm -rf /tmp/otrs-old.tmp
fi

# OTRS 2.0 -> OTRS 2.1
# remove old ticket config file
if test -e /opt/otrs/Kernel/Config/Files/Ticket.pm; then
    mv /opt/otrs/Kernel/Config/Files/Ticket.pm /opt/otrs/Kernel/Config/Files/Ticket.pm.not_longer_used
fi;
# remove old ticket postmaster config file
if test -e /opt/otrs/Kernel/Config/Files/TicketPostMaster.pm; then
    mv /opt/otrs/Kernel/Config/Files/TicketPostMaster.pm /opt/otrs/Kernel/Config/Files/TicketPostMaster.pm.not_longer_used;
fi
# remove old faq config file
if test -e /opt/otrs/Kernel/Config/Files/FAQ.pm; then
    mv /opt/otrs/Kernel/Config/Files/FAQ.pm /opt/otrs/Kernel/Config/Files/FAQ.pm.not_longer_used;
fi

#/opt/otrs/bin/otrs.SetPermissions.pl /opt/otrs %{_otrsusr} %{_apausr} %{_otrsgrp} %{_apagrp}
/opt/otrs/bin/otrs.SetPermissions.pl --otrs-user=%{_otrsusr} --web-user=%{_apausr} --otrs-group=%{_otrsgrp} --web-group=%{_apagrp} /opt/otrs 

# note
HOST=`hostname -f`
echo ""
echo "Next steps: "
echo ""
%if 0%{?suse_version}
echo "[SuSEconfig]"
echo " Execute 'SuSEconfig' to configure the webserver."
%else
echo "[mysqld service]"
echo " Start mysqld 'service mysqld start'"
%endif
echo ""
echo "[start Apache and MySQL]"
echo " Execute 'rcapache2 restart' and 'rcmysql start' in case they don't run."
echo ""
echo "[install the OTRS database]"
echo " Use a webbrowser and open this link:"
echo " http://$HOST/otrs/installer.pl"
echo ""
echo "[OTRS services]"
%if 0%{?suse_version}
echo " Start OTRS 'rcotrs start-force' (rcotrs {start|stop|status|restart|start-force|stop-force})."
%else
echo " Start OTRS 'service otrs start' (service otrs {start|stop|status|restart)."
%endif
echo ""
echo "((enjoy))"
echo ""
echo " Your OTRS Team"
echo " http://otrs.org/"
echo ""

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%if 0%{?suse_version}
/var/adm/fillup-templates/sysconfig.otrs
%else
%config(noreplace) /etc/sysconfig/otrs
%endif
%config %{_apaconfdir}/otrs.conf

%{_initdir}/otrs
%if 0%{?suse_version}
%{_sbindir}/rcotrs
%endif

%config(noreplace) /opt/otrs/Kernel/Config.pm
%config(noreplace) /opt/otrs/Kernel/Config/GenericAgent.pm
##%config(noreplace) /opt/otrs/var/log/TicketCounter.log
%config(noreplace) /opt/otrs/.procmailrc
%config(noreplace) /opt/otrs/.fetchmailrc
%config(noreplace) /opt/otrs/.mailfilter
%config(noreplace) /opt/otrs/Kernel/Output/HTML/Standard/*.dtl
##%config(noreplace) /opt/otrs/Kernel/Output/HTML/Lite/*.dtl
%config(noreplace) /opt/otrs/Kernel/Language/*.pm
%config(noreplace) /opt/otrs/var/cron/*
%config(noreplace) /opt/otrs/var/logo-otrs.png

%dir /opt/otrs/
%dir /opt/otrs/Custom
/opt/otrs/Custom/README
/opt/otrs/RELEASE
/opt/otrs/ARCHIVE
/opt/otrs/.procmailrc.dist
/opt/otrs/.fetchmailrc.dist
/opt/otrs/.mailfilter.dist
%dir /opt/otrs/Kernel/
%dir /opt/otrs/Kernel/Config/
/opt/otrs/Kernel/Config.pm.dist
/opt/otrs/Kernel/Config/Files/
/opt/otrs/Kernel/Config/GenericAgent.pm.dist
/opt/otrs/Kernel/Config/GenericAgent.pm.examples
/opt/otrs/Kernel/Config/Defaults.pm
/opt/otrs/Kernel/Language.pm
%dir /opt/otrs/Kernel/Language/
/opt/otrs/Kernel/Modules*
%dir /opt/otrs/Kernel/Output/
%dir /opt/otrs/Kernel/Output/HTML/
%dir /opt/otrs/Kernel/Output/HTML/Standard/
##%dir /opt/otrs/Kernel/Output/HTML/Lite/
/opt/otrs/Kernel/Output/HTML/*.pm
/opt/otrs/Kernel/System*
/opt/otrs/bin*
/opt/otrs/scripts*
%dir /opt/otrs/var/
%dir /opt/otrs/var/article/
/opt/otrs/var/httpd/
%dir /opt/otrs/var/log/
%dir /opt/otrs/var/sessions/
%dir /opt/otrs/var/spool/
%dir /opt/otrs/var/cron/
%dir /opt/otrs/var/tmp/
##%dir /opt/otrs/var/pics
##%dir /opt/otrs/var/pics/stats/
%dir /opt/otrs/var/packages
/opt/otrs/var/packages/Support-*.opm
/opt/otrs/Kernel/cpan-lib*
%dir /opt/otrs/var/stats
/opt/otrs/var/stats/ListOfOpenTicketsSortedByTimeLeftUntilEscalationDeadlineExpires.de.xml
/opt/otrs/var/stats/ListOfOpenTicketsSortedByTimeLeftUntilEscalationDeadlineExpires.en.xml
/opt/otrs/var/stats/ListOfOpenTicketsSortedByTimeLeftUntilResponseDeadlineExpires.de.xml
/opt/otrs/var/stats/ListOfOpenTicketsSortedByTimeLeftUntilResponseDeadlineExpires.en.xml
/opt/otrs/var/stats/ListOfOpenTicketsSortedByTimeLeftUntilSolutionDeadlineExpires.de.xml
/opt/otrs/var/stats/ListOfOpenTicketsSortedByTimeLeftUntilSolutionDeadlineExpires.en.xml
/opt/otrs/var/stats/ListOfTheMostTimeConsumingTickets.de.xml
/opt/otrs/var/stats/ListOfTheMostTimeConsumingTickets.en.xml
/opt/otrs/var/stats/ListOfTicketsClosedLastMonth.de.xml
/opt/otrs/var/stats/ListOfTicketsClosedLastMonth.en.xml
/opt/otrs/var/stats/ListOfTicketsClosedSortedByResponseTime.de.xml
/opt/otrs/var/stats/ListOfTicketsClosedSortedByResponseTime.en.xml
/opt/otrs/var/stats/ListOfTicketsClosedSortedBySolutionTime.de.xml
/opt/otrs/var/stats/ListOfTicketsClosedSortedBySolutionTime.en.xml
/opt/otrs/var/stats/ListOfTicketsCreatedLastMonth.de.xml
/opt/otrs/var/stats/ListOfTicketsCreatedLastMonth.en.xml
/opt/otrs/var/stats/Stats.NewTickets.de.xml
/opt/otrs/var/stats/Stats.NewTickets.en.xml
/opt/otrs/var/stats/Stats.StatusActionOverview.de.xml
/opt/otrs/var/stats/Stats.StatusActionOverview.en.xml
/opt/otrs/var/stats/Stats.TicketOverview.de.xml
/opt/otrs/var/stats/Stats.TicketOverview.en.xml
%dir /opt/otrs/var/fonts
/opt/otrs/var/fonts/DejaVuSans-Bold.ttf
/opt/otrs/var/fonts/DejaVuSans-BoldOblique.ttf
/opt/otrs/var/fonts/DejaVuSans-Oblique.ttf
/opt/otrs/var/fonts/DejaVuSans.ttf
/opt/otrs/var/fonts/DejaVuSansMono-Bold.ttf
/opt/otrs/var/fonts/DejaVuSansMono-BoldOblique.ttf
/opt/otrs/var/fonts/DejaVuSansMono-Oblique.ttf
/opt/otrs/var/fonts/DejaVuSansMono.ttf
%doc /opt/otrs/INSTAL*
%doc /opt/otrs/UPGRADING
%doc /opt/otrs/COPYING
%doc /opt/otrs/CHANGES
%doc /opt/otrs/READM*
%doc /opt/otrs/doc*
%doc /opt/otrs/CREDITS
%doc /opt/otrs/COPYING-Third-Party
%dir /opt/otrs/Kernel/GenericInterface
/opt/otrs/Kernel/GenericInterface/Debugger.pm
%dir /opt/otrs/Kernel/GenericInterface/Event
/opt/otrs/Kernel/GenericInterface/Event/Handler.pm
/opt/otrs/Kernel/GenericInterface/Invoker.pm
%dir /opt/otrs/Kernel/GenericInterface/Invoker
%dir /opt/otrs/Kernel/GenericInterface/Invoker/Test
/opt/otrs/Kernel/GenericInterface/Invoker/Test/Test.pm
/opt/otrs/Kernel/GenericInterface/Invoker/Test/TestSimple.pm
/opt/otrs/Kernel/GenericInterface/Mapping.pm
%dir /opt/otrs/Kernel/GenericInterface/Mapping
/opt/otrs/Kernel/GenericInterface/Mapping/Simple.pm
/opt/otrs/Kernel/GenericInterface/Mapping/Test.pm
/opt/otrs/Kernel/GenericInterface/Operation.pm
%dir /opt/otrs/Kernel/GenericInterface/Operation
/opt/otrs/Kernel/GenericInterface/Operation/Common.pm
%dir /opt/otrs/Kernel/GenericInterface/Operation/Session
/opt/otrs/Kernel/GenericInterface/Operation/Session/Common.pm
/opt/otrs/Kernel/GenericInterface/Operation/Session/SessionCreate.pm
%dir /opt/otrs/Kernel/GenericInterface/Operation/Test
/opt/otrs/Kernel/GenericInterface/Operation/Test/Test.pm
%dir /opt/otrs/Kernel/GenericInterface/Operation/Ticket
/opt/otrs/Kernel/GenericInterface/Operation/Ticket/Common.pm
/opt/otrs/Kernel/GenericInterface/Operation/Ticket/TicketCreate.pm
/opt/otrs/Kernel/GenericInterface/Operation/Ticket/TicketGet.pm
/opt/otrs/Kernel/GenericInterface/Operation/Ticket/TicketSearch.pm
/opt/otrs/Kernel/GenericInterface/Operation/Ticket/TicketUpdate.pm
/opt/otrs/Kernel/GenericInterface/Provider.pm
/opt/otrs/Kernel/GenericInterface/Requester.pm
/opt/otrs/Kernel/GenericInterface/Transport.pm
%dir /opt/otrs/Kernel/GenericInterface/Transport
%dir /opt/otrs/Kernel/GenericInterface/Transport/HTTP
/opt/otrs/Kernel/GenericInterface/Transport/HTTP/REST.pm
/opt/otrs/Kernel/GenericInterface/Transport/HTTP/SOAP.pm
/opt/otrs/Kernel/GenericInterface/Transport/HTTP/Test.pm
%dir /opt/otrs/Kernel/Scheduler
/opt/otrs/Kernel/Scheduler.pm
/opt/otrs/Kernel/Scheduler/TaskHandler.pm
%dir /opt/otrs/Kernel/Scheduler/TaskHandler
/opt/otrs/Kernel/Scheduler/TaskHandler/GenericInterface.pm
/opt/otrs/Kernel/Scheduler/TaskHandler/Test.pm

%changelog
* Tue Jun 18 2013 cs@linux-administrator.com
- update to release 3.1.17
* Sat Sep 15 2012 cs@linux-administrator.com
- update to release 3.1.10
* Tue Sep  4 2012 cs@linux-administrator.com
- update to release 3.1.9
